#include <windows.h>
#include <stdio.h>
#include "resource.h"

#define    XSIZE     800
#define    YSIZE     600

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DialogProc (HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
void InitDialog (HWND hWnd, HINSTANCE hInst);


char szClassName[] = "Basic class";    // Ŭ
char szChildClassName[] = "Child class";
HWND        g_hWnd  = NULL;
HINSTANCE   g_hInst = NULL;
HWND        g_hDlg = NULL;
HWND        g_hChildWnd;


ATOM InitApp (HINSTANCE hInst)
{
    WNDCLASSEX wc;
    wc.cbSize = sizeof(WNDCLASSEX);
    wc.style =  CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WndProc;  
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInst;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName = "MAINMENU";    
    wc.lpszClassName = (LPCSTR) szClassName;
    wc.hIconSm  = NULL;
    return (RegisterClassEx(&wc));
}

BOOL InitInstance (HINSTANCE hInst, int nCmdShow)
{
    HWND hWnd;

    hWnd = CreateWindow(szClassName,
            "Ʈ  ",
            WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME & ~WS_MAXIMIZEBOX,
            CW_USEDEFAULT,    
            CW_USEDEFAULT,    
            XSIZE,    
            YSIZE,    
            NULL, 
            NULL, //޴ ڵ, Ŭ ޴   NULL
            hInst, 
            NULL);
    if (! hWnd)
        return FALSE;

	g_hWnd = hWnd;

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    return TRUE;
}

LRESULT CALLBACK ChildWndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HRGN hRgn;

    switch (msg) 
	{ 
    case  WM_CREATE:   
        hRgn = CreateRoundRectRgn(0,0,100,100,100,90); 
        SetWindowRgn(hWnd, hRgn,TRUE); 
		DeleteObject(hRgn);
		break;
    case  WM_LBUTTONDOWN:
		MessageBox(hWnd, "Child Button", "Child", MB_OK);
		break;
    default:
          return (DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return 0;
}


BOOL MakeChildWidnow (HWND hParentWnd)
{
    HWND hWnd;

    WNDCLASSEX wc;
    wc.cbSize = sizeof(WNDCLASSEX);
    wc.style =  CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = ChildWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = (HINSTANCE)GetWindowLong(hParentWnd, GWL_HINSTANCE);
	wc.hIcon = NULL;
    wc.hCursor = LoadCursor(NULL, IDC_CROSS);
    wc.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
    wc.lpszMenuName = NULL;   
    wc.lpszClassName = (LPCSTR) szChildClassName;
    wc.hIconSm  = NULL;
    
	if (!RegisterClassEx(&wc))
		         return FALSE;


    hWnd = CreateWindow(szChildClassName,
            "Child Window",
            WS_CHILD,
            50,    
            50,    
            100,    
            100,    
            hParentWnd, 
            NULL, //޴ ڵ, Ŭ ޴   NULL
            (HINSTANCE)GetWindowLong(hParentWnd, GWL_HINSTANCE), 
            NULL);
    if (! hWnd)
        return FALSE;

	g_hChildWnd = hWnd;

    ShowWindow(hWnd, true);
    UpdateWindow(hWnd);
    return TRUE;
}


int WINAPI WinMain (HINSTANCE hCurInst, HINSTANCE hPrevInst, LPSTR lpsCmdLine, int nCmdShow)
{
    MSG msg;
    
    g_hInst = hCurInst;
    if (! InitApp(hCurInst))
        return FALSE;
    if (! InitInstance(hCurInst, nCmdShow)) 
        return FALSE;
    while (GetMessage(&msg, NULL, 0, 0))
	{
		if ((g_hDlg== 0) || ! IsDialogMessage(g_hDlg, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
    }
    return 0;
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg) 
	{
        case WM_CREATE:
			InitDialog(hWnd, g_hInst);
			MakeChildWidnow(hWnd);
            break;
        case WM_COMMAND:
            switch (LOWORD(wParam)) 
			{
                case IDM_END:
                    SendMessage(hWnd, WM_CLOSE, 0, 0);
                    break;
                case  IDM_TEST:
				    MessageBox(hWnd, "Test", "Test", MB_OK);
					break;
                default:
					break;
            }
			break;

		case  WM_LBUTTONDOWN:
		    MessageBox(hWnd, "Parent Button", "Parent", MB_OK);
		    break;

		case WM_PAINT:
			{
				HDC    hdc;
				PAINTSTRUCT ps;
				hdc=BeginPaint(hWnd, &ps);
				SetTextColor(hdc, RGB(255, 50, 50));
				SetBkColor(hdc, RGB(50, 255, 50));
				TextOut(hdc, 360, 200, "WM_PAINT Դϴ...", 
											 strlen("WM_PAINT Դϴ..."));
				EndPaint(hWnd, &ps);
			    return 0;
			}
        case WM_CLOSE:              
            DestroyWindow(hWnd);
            break;
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
          
        default:
            return (DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return 0;
}
//------------------------------------------------------------------------------------------
bool Do_WM_COMMAND (WPARAM wParam, LPARAM lParam)
{
	int id;
	id = LOWORD(wParam);

    switch (id) 
	{
	case IDC_OUTPUT:
		{
			char *boy = "I am a boy.";
			HWND hEdit;
			hEdit = GetDlgItem(g_hDlg, IDC_EDIT);
			SetWindowText( hEdit, boy);
            return true;
		}
    case IDC_BUTTON1:
		{
            HDC hdc = GetDC(g_hChildWnd);
			SetTextColor(hdc, RGB(255, 50, 50));
			SetBkColor(hdc, RGB(50, 255, 50));
			TextOut(hdc, 20, 40, "ư ϳ ..Դϴ..", 
				                         strlen("ư ϳ ..Դϴ.."));
			ReleaseDC(g_hChildWnd, hdc);
			return true;
		}
	}
    return false;
}
//------------------------------------------------------------------------------------------
LRESULT CALLBACK DialogProc (HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) 
	{
    case WM_INITDIALOG:
		return TRUE;
    case WM_COMMAND:
		Do_WM_COMMAND(wParam, lParam);
		return TRUE;
	default:
		break;
	}
	return FALSE;
}
//------------------------------------------------------------------------------------------
void InitDialog (HWND hWnd, HINSTANCE hInst)
{
	RECT rc;
	int  xSize, ySize;
    
	if (g_hDlg)
		   return;
    g_hDlg = CreateDialog(hInst, "MAINDLG", hWnd, (DLGPROC) DialogProc);
    if (g_hDlg) 
	{
          ShowWindow(g_hDlg, SW_SHOW);
          GetWindowRect(g_hDlg, &rc);
          xSize = rc.right - rc.left + 1;
          ySize = rc.bottom - rc.top + 1;
          GetClientRect(hWnd, &rc);
          MoveWindow(g_hDlg, rc.right - xSize + 1, rc.top, rc.right, rc.bottom, TRUE);
    } 
}
